open Datatypes
open EqNat
open List0
open MinMax
open Option
open Peano
open Specification

type __ = Obj.t

module type TYPE = 
 functor (BsmlPrimitives:PRIMITIVES) ->
 functor (BsmlPropertiesM:sig 
  val max_pid : nat
  
  val firstProcessor : BsmlPrimitives.processor
  
  val lastProcessor : BsmlPrimitives.processor
  
  val processorOfNatMod : nat -> BsmlPrimitives.processor
  
  val processorEqDec :
    BsmlPrimitives.processor -> BsmlPrimitives.processor -> bool
  
  val processor_beq :
    BsmlPrimitives.processor -> BsmlPrimitives.processor -> bool
  
  val processors : BsmlPrimitives.processor list
  
  val processorsUpTo :
    BsmlPrimitives.processor -> BsmlPrimitives.processor list
  
  val processorsStartingAt :
    BsmlPrimitives.processor -> BsmlPrimitives.processor list
  
  val processorsRevInduction_obligation_2 :
    (BsmlPrimitives.processor -> BsmlPrimitives.processor -> __ -> __ -> 'a1
    -> 'a1) -> 'a1 -> 'a1
  
  val processorsRevInduction :
    (BsmlPrimitives.processor -> BsmlPrimitives.processor -> __ -> __ -> 'a1
    -> 'a1) -> 'a1 -> 'a1
  
  val listOfParList : 'a1 list BsmlPrimitives.par -> 'a1 list
 end) ->
 functor (ParSigM:sig 
  val parSig : 'a1 BsmlPrimitives.par -> 'a1 BsmlPrimitives.par
  
  val parInSig : 'a1 list BsmlPrimitives.par -> 'a1 list BsmlPrimitives.par
 end) ->
 functor (BsmlBaseM:sig 
  val replicate : 'a1 -> 'a1 BsmlPrimitives.par
  
  val parfun :
    ('a1 -> 'a2) -> 'a1 BsmlPrimitives.par -> 'a2 BsmlPrimitives.par
  
  val parfun2 :
    ('a1 -> 'a2 -> 'a3) -> 'a1 BsmlPrimitives.par -> 'a2 BsmlPrimitives.par
    -> 'a3 BsmlPrimitives.par
  
  val mask :
    (BsmlPrimitives.processor -> bool) -> 'a1 BsmlPrimitives.par -> 'a1
    BsmlPrimitives.par -> 'a1 BsmlPrimitives.par
  
  val parfunif :
    (BsmlPrimitives.processor -> bool) -> ('a1 -> 'a2) -> ('a1 -> 'a2) -> 'a1
    BsmlPrimitives.par -> 'a2 BsmlPrimitives.par
  
  val applyif :
    (BsmlPrimitives.processor -> bool) -> ('a1 -> 'a2) BsmlPrimitives.par ->
    ('a1 -> 'a2) BsmlPrimitives.par -> 'a1 BsmlPrimitives.par -> 'a2
    BsmlPrimitives.par
  
  val parfunat :
    BsmlPrimitives.processor -> ('a1 -> 'a2) -> ('a1 -> 'a2) -> 'a1
    BsmlPrimitives.par -> 'a2 BsmlPrimitives.par
  
  val applyat :
    BsmlPrimitives.processor -> ('a1 -> 'a2) BsmlPrimitives.par -> ('a1 ->
    'a2) BsmlPrimitives.par -> 'a1 BsmlPrimitives.par -> 'a2
    BsmlPrimitives.par
  
  val this : BsmlPrimitives.processor BsmlPrimitives.par
  
  val procs : BsmlPrimitives.processor list
  
  val get_one_aux :
    'a1 BsmlPrimitives.par -> nat BsmlPrimitives.par -> 'a1 option
    BsmlPrimitives.par
  
  val get_one :
    'a1 BsmlPrimitives.par -> nat BsmlPrimitives.par -> 'a1
    BsmlPrimitives.par
  
  val get_list_aux :
    'a1 BsmlPrimitives.par -> nat list BsmlPrimitives.par -> 'a1 option list
    BsmlPrimitives.par
  
  val get_list :
    'a1 BsmlPrimitives.par -> nat list BsmlPrimitives.par -> 'a1 list
    BsmlPrimitives.par
  
  val put_one :
    (nat, 'a1) prod BsmlPrimitives.par -> 'a1 list BsmlPrimitives.par
  
  val put_list :
    (nat, 'a1) prod list BsmlPrimitives.par -> 'a1 list BsmlPrimitives.par
 end) ->
 sig 
  val heatEquationFormula :
    float -> float -> float -> float ->
    float -> float -> float
  
  val heatEquationSeq :
    float -> float -> float -> float ->
    float -> float list -> float list
  
  val projPar : 'a1 BsmlPrimitives.par -> 'a1 BsmlPrimitives.par
  
  val strongHead : 'a1 list -> 'a1
  
  val sHead : 'a1 list -> 'a1
  
  val last_error : 'a1 list -> 'a1 option
  
  val strongLast : 'a1 list -> 'a1
  
  val sLast : 'a1 list -> 'a1
  
  val constantFunPar : 'a2 -> ('a1 -> 'a2) BsmlPrimitives.par
  
  val getBoundsAux :
    'a1 -> 'a1 -> 'a1 list BsmlPrimitives.par -> ('a1 option
    BsmlPrimitives.par, 'a1 option BsmlPrimitives.par) prod
  
  val getBounds :
    'a1 -> 'a1 -> 'a1 list BsmlPrimitives.par -> ('a1 BsmlPrimitives.par, 'a1
    BsmlPrimitives.par) prod
  
  val heatEquationPar :
    float -> float -> float -> float ->
    float -> float list BsmlPrimitives.par -> float
    list BsmlPrimitives.par
  
  val rightBoundAtI :
    float -> float list BsmlPrimitives.par ->
    BsmlPrimitives.processor -> float
  
  val leftBoundAtI :
    float -> float list BsmlPrimitives.par ->
    BsmlPrimitives.processor -> float
 end

module Make : 
 functor (BsmlPrimitives:PRIMITIVES) ->
 functor (BsmlPropertiesM:sig 
  val max_pid : nat
  
  val firstProcessor : BsmlPrimitives.processor
  
  val lastProcessor : BsmlPrimitives.processor
  
  val processorOfNatMod : nat -> BsmlPrimitives.processor
  
  val processorEqDec :
    BsmlPrimitives.processor -> BsmlPrimitives.processor -> bool
  
  val processor_beq :
    BsmlPrimitives.processor -> BsmlPrimitives.processor -> bool
  
  val processors : BsmlPrimitives.processor list
  
  val processorsUpTo :
    BsmlPrimitives.processor -> BsmlPrimitives.processor list
  
  val processorsStartingAt :
    BsmlPrimitives.processor -> BsmlPrimitives.processor list
  
  val processorsRevInduction_obligation_2 :
    (BsmlPrimitives.processor -> BsmlPrimitives.processor -> __ -> __ -> 'a1
    -> 'a1) -> 'a1 -> 'a1
  
  val processorsRevInduction :
    (BsmlPrimitives.processor -> BsmlPrimitives.processor -> __ -> __ -> 'a1
    -> 'a1) -> 'a1 -> 'a1
  
  val listOfParList : 'a1 list BsmlPrimitives.par -> 'a1 list
 end) ->
 functor (ParSigM:sig 
  val parSig : 'a1 BsmlPrimitives.par -> 'a1 BsmlPrimitives.par
  
  val parInSig : 'a1 list BsmlPrimitives.par -> 'a1 list BsmlPrimitives.par
 end) ->
 functor (BsmlBaseM:sig 
  val replicate : 'a1 -> 'a1 BsmlPrimitives.par
  
  val parfun :
    ('a1 -> 'a2) -> 'a1 BsmlPrimitives.par -> 'a2 BsmlPrimitives.par
  
  val parfun2 :
    ('a1 -> 'a2 -> 'a3) -> 'a1 BsmlPrimitives.par -> 'a2 BsmlPrimitives.par
    -> 'a3 BsmlPrimitives.par
  
  val mask :
    (BsmlPrimitives.processor -> bool) -> 'a1 BsmlPrimitives.par -> 'a1
    BsmlPrimitives.par -> 'a1 BsmlPrimitives.par
  
  val parfunif :
    (BsmlPrimitives.processor -> bool) -> ('a1 -> 'a2) -> ('a1 -> 'a2) -> 'a1
    BsmlPrimitives.par -> 'a2 BsmlPrimitives.par
  
  val applyif :
    (BsmlPrimitives.processor -> bool) -> ('a1 -> 'a2) BsmlPrimitives.par ->
    ('a1 -> 'a2) BsmlPrimitives.par -> 'a1 BsmlPrimitives.par -> 'a2
    BsmlPrimitives.par
  
  val parfunat :
    BsmlPrimitives.processor -> ('a1 -> 'a2) -> ('a1 -> 'a2) -> 'a1
    BsmlPrimitives.par -> 'a2 BsmlPrimitives.par
  
  val applyat :
    BsmlPrimitives.processor -> ('a1 -> 'a2) BsmlPrimitives.par -> ('a1 ->
    'a2) BsmlPrimitives.par -> 'a1 BsmlPrimitives.par -> 'a2
    BsmlPrimitives.par
  
  val this : BsmlPrimitives.processor BsmlPrimitives.par
  
  val procs : BsmlPrimitives.processor list
  
  val get_one_aux :
    'a1 BsmlPrimitives.par -> nat BsmlPrimitives.par -> 'a1 option
    BsmlPrimitives.par
  
  val get_one :
    'a1 BsmlPrimitives.par -> nat BsmlPrimitives.par -> 'a1
    BsmlPrimitives.par
  
  val get_list_aux :
    'a1 BsmlPrimitives.par -> nat list BsmlPrimitives.par -> 'a1 option list
    BsmlPrimitives.par
  
  val get_list :
    'a1 BsmlPrimitives.par -> nat list BsmlPrimitives.par -> 'a1 list
    BsmlPrimitives.par
  
  val put_one :
    (nat, 'a1) prod BsmlPrimitives.par -> 'a1 list BsmlPrimitives.par
  
  val put_list :
    (nat, 'a1) prod list BsmlPrimitives.par -> 'a1 list BsmlPrimitives.par
 end) ->
 sig 
  val heatEquationFormula :
    float -> float -> float -> float ->
    float -> float -> float
  
  val heatEquationSeq :
    float -> float -> float -> float ->
    float -> float list -> float list
  
  val projPar : 'a1 BsmlPrimitives.par -> 'a1 BsmlPrimitives.par
  
  val strongHead : 'a1 list -> 'a1
  
  val sHead : 'a1 list -> 'a1
  
  val last_error : 'a1 list -> 'a1 option
  
  val strongLast : 'a1 list -> 'a1
  
  val sLast : 'a1 list -> 'a1
  
  val constantFunPar : 'a2 -> ('a1 -> 'a2) BsmlPrimitives.par
  
  val getBoundsAux :
    'a1 -> 'a1 -> 'a1 list BsmlPrimitives.par -> ('a1 option
    BsmlPrimitives.par, 'a1 option BsmlPrimitives.par) prod
  
  val getBounds :
    'a1 -> 'a1 -> 'a1 list BsmlPrimitives.par -> ('a1 BsmlPrimitives.par, 'a1
    BsmlPrimitives.par) prod
  
  val heatEquationPar :
    float -> float -> float -> float ->
    float -> float list BsmlPrimitives.par -> float
    list BsmlPrimitives.par
  
  val rightBoundAtI :
    float -> float list BsmlPrimitives.par ->
    BsmlPrimitives.processor -> float
  
  val leftBoundAtI :
    float -> float list BsmlPrimitives.par ->
    BsmlPrimitives.processor -> float
 end

