Require Import List.
Lemma filter_app (E:Type) (f:E -> bool)(l1 l2 : list E) : 
  filter f (l1 ++ l2) = filter f  l1++(filter f l2).
Proof.
  induction l1.
  reflexivity.
  simpl.
  rewrite IHl1.
  destruct (f a);
  reflexivity.
Qed.



Definition filterMap (A B :  Type) (select :  B -> bool) (f  : A -> B):=
  let fix aux l :=
    match l with 
      nil => nil
      |x::l' => let x':=f x in if select x' then x'::aux l' else aux l'
    end
    in
    aux.

Implicit Arguments  filterMap [A B].

Lemma filterMapFusion (A B :Type) (select :  A -> bool) (f  : B -> A) :
  forall l,
  filter select (map f l) =  filterMap select f  l.
Proof.
  induction l; simpl.
  reflexivity.
  destruct (select (f a)).
  rewrite <- IHl. reflexivity.
  auto.
Qed.

Implicit Arguments  filterMapFusion [A B].
Hint Rewrite  filterMapFusion : optimization.
