Require Import LIFO.List.Length.

Set Implicit Arguments.

Section FixedLengthLists.
  
  Variable A : Type.

  Definition list (len:nat) := 
    { l:List.list A | List.length l = len }.

  Program Definition nil : { l : list 0 | l = List.nil } := List.nil. 

  Program Definition cons (len:nat) (a:A) (l:list len) : 
    { l' : list (S len) | proj1_sig l' = List.cons a l } := 
    List.cons a l.
  Next Obligation.
    destruct l; auto. 
  Qed. 

  Program Definition app (len1 len2 : nat) (l1:list len1) `(l2:list len2) : 
    { l: list (len1+len2) | proj1_sig l = List.app l1 l2 } :=
    List.app l1 l2.
  Next Obligation.
    autorewrite with length.
    destruct l1; destruct l2.
    auto.
  Qed.

End FixedLengthLists.

  

