Require Import Arith.
Require Import Mergesort.
Require Import Permutation.
Require Import LIFO.List.Length.

Module Make(Import X:Orders.TotalLeBool').

  Module Import MergeSort := Sort X.

  Lemma mergeLength:
    forall(l1 l2: list X.t),
      length(merge l1 l2) = length l1 + length l2.
  Proof.
    induction l1 as [ |h1 l1']; intros l2; [
      simpl; replace((fix merge_aux l0 : list t := l0)l2) with l2 by (induction l2; auto); simpl; auto|
      induction l2 as [| h2 l2']; [
        auto |
        simpl; destruct(h1<=? h2); [
          simpl; rewrite IHl1'; auto |
          simpl in *; rewrite IHl2'; auto ] ] ].
  Qed.

  Hint Rewrite mergeLength: length.

  Lemma sortLength:
    forall (l: list X.t), 
      length(sort l) = length l.
  Proof.
    intros l; apply Permutation_length; apply Permutation_sym; apply Permuted_sort.
  Qed.

  Hint Rewrite sortLength: length.

End Make.

(* *)