Require Import List.
Require Import Setoid.

Lemma rev_append_prop:
  forall (A:Type) (l l1 l2:list A),
    rev_append l (l1++l2) = (rev_append l l1) ++ l2.
Proof.
  intros A l.
  induction l.
    reflexivity.
    simpl in *.
    setoid_rewrite <- IHl.
    reflexivity.
Qed.


Lemma rev_rev':
  forall (A:Type) (l:list A), 
    rev l = rev' l.
Proof.
  intros A l.
  unfold rev'.
  induction l. 
    reflexivity.
    simpl. 
    rewrite IHl. rewrite <- rev_append_prop. reflexivity.
Qed.
