Require Import  List.
Require Import  CertifiedBSML.QuickStart.
Require Import SDPP.CorrectParallelisation.Structure.
Require Import SDPP.Datatypes.Lists.Lists.
Require Import SDPP.Skel.BasicsList.
Require Import  LIFO.Algebra.AlgebraClasses.
Require Import SDPP.Skel.map_around.
Require Import SDPP.Skel.LastPar.
Require Import SDPP.Skel.scan.
Require Import SDPP.Skel.homomorphism.

Module ComptagePar
  (BsmlPrimitives: Primitives.Specification.PRIMITIVES)
  (BsmlPropertiesM : Primitives.Properties.TYPE(BsmlPrimitives))
  (ParSigM : Support.ParSig.TYPE(BsmlPrimitives)(BsmlPropertiesM))
  (BsmlBaseM : StandardLibrary.Base.TYPE(BsmlPrimitives)(BsmlPropertiesM)(ParSigM))
  (Parallel : Parallelisation)
  (ListPart : Lists.TYPE   BsmlPrimitives BsmlPropertiesM ParSigM BsmlBaseM   Parallel)
  (BasicSkel :  BasicsList.TYPE BsmlPrimitives BsmlPropertiesM ParSigM BsmlBaseM Parallel ListPart)
  (Bsml_bh : bh_bsml.TYPE  BsmlPrimitives BsmlPropertiesM ParSigM BsmlBaseM Parallel ListPart) 
  (Bh_Classes : bh_classes.TYPE  BsmlPrimitives BsmlPropertiesM ParSigM BsmlBaseM Parallel ListPart Bsml_bh)
  (Ma : map_around.TYPE   BsmlPrimitives BsmlPropertiesM ParSigM BsmlBaseM Parallel ListPart Bsml_bh Bh_Classes)
  (LastParallel : LastPar.TYPE BsmlPrimitives BsmlPropertiesM ParSigM BsmlBaseM Parallel ListPart)
  (Scan  : scan.TYPE BsmlPrimitives BsmlPropertiesM ParSigM BsmlBaseM Parallel ListPart Bsml_bh Bh_Classes Ma) 
  (Homomorphism :homomorphism.TYPE BsmlPrimitives BsmlPropertiesM ParSigM BsmlBaseM Parallel ListPart Bsml_bh Bh_Classes Ma LastParallel). 

  Import BsmlPrimitives BsmlPropertiesM ParSigM BsmlBaseM Parallel BasicSkel Homomorphism.

Require Import Sumbool.
Require Import Arith.

Definition gtb x y := (proj1_sig (bool_of_sumbool (gt_dec x y))).
Infix   ">" := gtb .
(* end hide *) 


Definition counting (A:Type) (size : A-> nat) :=
(fun l => fold_left plus l 0) :o:(map (fun x => 1)) :o: (filter (fun x => x > 0)) :o: (map size).

Instance nat_part :Partitionnable nat := LastParallel.partition_A_default nat 0.

Definition countingParExtraction (A:Type) (size : A-> nat)  :=
  Eval simpl in parallel (f:=counting A size).

(* Print  countingParExtraction. *)


End ComptagePar.
(*  *)