Require Import SDPP.CorrectParallelisation.Structure.
Require Import CertifiedBSML.QuickStart.

Module TYPE (Bs : PRIMITIVES)
                     (Bsml_prop : Properties.TYPE Bs)  
                     (ParSig : ParSig.TYPE Bs Bsml_prop) 
                     (Bsml_base : Base.TYPE Bs Bsml_prop ParSig)  
                     (Parallel : Parallelisation ).
  Import Parallel.
  Import Bs.
  Import Bsml_prop.
  Import Bsml_base.

  Instance partition_A A : Partitionnable A | 1000  :=
    {
      join :=fun v => get v firstProcessor;
        partition := fun a =>proj1_sig (replicate a)
    }.
  intros a.
  unfold replicate. 
  autorewrite with bsml.
  reflexivity.
Defined.

End TYPE.

Module Make (Bs : PRIMITIVES)
                     (Bsml_prop : Properties.TYPE Bs)  
                     (ParSig : ParSig.TYPE Bs Bsml_prop) 
                     (Bsml_base : Base.TYPE Bs Bsml_prop ParSig)  
                     (Parallel : Parallelisation ).
  Include TYPE Bs Bsml_prop ParSig Bsml_base Parallel.
End Make.