(** *Folding generic Max  *)
Unset Automatic Introduction.    (* coq 8.3 *)
Require Import List.
Require Import Arith.

Require Import LIFO.List.Homomorphism.
Require Import LIFO.Algebra.AlgebraClasses.

Require Import SDPP.Misc.generic_max.
Require Import SDPP.Misc.total_order.

Module Type MAX_FOLDING_PARAMETERS.
  Variable A : Type.
  Variable R : relation A.
  Variable preoR : PreOrder R.
  Variable totR : TotalOrder (preo:=preoR) R.
  Variable min :A.
  Variable min_smallest : forall a, R min  a.
End  MAX_FOLDING_PARAMETERS.  

Module Maximum_Fold                (mfp : MAX_FOLDING_PARAMETERS).

  Module Maximum := (Generic_Max mfp).
  Export Maximum.

  Definition maximum_fold (l:list A):=List.fold_left Max l min.


Global Instance maximum_fold_is_an_homomorphism : 
  Homomorphism'  Max maximum_fold.
Proof.
  apply (foldleft_is_an_homomorphism Max min).
  constructor. apply max_assoc.
  constructor; constructor; 
   unfold Max; 
   intro a; [destructAdHoc ( min ?<= a )| destructAdHoc ( a?<= min  )];
     try reflexivity; 
    generalize (min_smallest a); intro r0;
      apply antisymmetry; auto. 
Qed.

Global Instance min_neutral  : Neutral Max min :=min_unit (min_smallest := min_smallest) .

End Maximum_Fold.