Require Import List.
Require Import Arith.
Require Import Omega.

Require Import CertifiedBSML.QuickStart.
Require Import SDPP.Skel.map_around.
Require Import SDPP.Skel.scan.

Require Import LIFO.List.Triple_lists.
Require Import LIFO.List.Inits_tails.
Require Import LIFO.List.Fold.      
  
Require Import LIFO.Option.Option.
Require Import LIFO.Algebra.AlgebraClasses.

Require Import SDPP.Skel.homomorphism.

Module Type FoldLeftPar (Bs : PRIMITIVES) 
  (Bsml_prop : Properties.TYPE Bs) 
  (ParSig : ParSig.TYPE Bs Bsml_prop) 
  (Bsml_base : Base.TYPE Bs Bsml_prop ParSig)  
  (Parallel : Parallelisation )
  (Partition : Lists.TYPE Bs Bsml_prop ParSig Bsml_base Parallel)
  (Bsml_bh : bh_bsml.TYPE  Bs Bsml_prop ParSig Bsml_base Parallel Partition) 
  (Bh_Classes : bh_classes.TYPE Bs Bsml_prop ParSig Bsml_base Parallel Partition Bsml_bh)
  (Ma : map_around.TYPE  Bs Bsml_prop ParSig Bsml_base Parallel Partition Bsml_bh Bh_Classes)
  (LastParallel : LastPar.TYPE Bs Bsml_prop ParSig Bsml_base Parallel Partition)
  (Scan  : scan.TYPE Bs Bsml_prop ParSig Bsml_base Parallel Partition Bsml_bh Bh_Classes Ma) 
  (Homomorphism :homomorphism.TYPE Bs Bsml_prop ParSig Bsml_base Parallel Partition Bsml_bh Bh_Classes Ma LastParallel). 

  Import  Parallel Bh_Classes Homomorphism.

(*   Global  Instance gl_fold_homomorphism{A: Type} {op : A-> A ->A} {e : A} {e_neutral : Neutral op e} {op_assoc : Associative  op} : Homomorphism'' (eqB:=eq) op (fun lst => fold_left op lst e) . *)
(* constructor. *)

(* destruct (foldleft_is_an_homomorphism _ _ _ _ ).  *)
(* firstorder. *)
(* Defined. *)

     (* Global Instance   fold_leftParCorrect : Parallel(fun lst => fold_left op lst e) _ := homomorphism_Parallel _ _ op (fun lst => fold_left op lst e). *)

(* Implicit Arguments homo_result_part [[A] [op] [h] [homo_h]]. *)
(* Existing Instance homo_result_part. *)


   (*  Check (fun A (op : A-> A ->A) (e : A)   (h : list A -> A)   (_ : Homomorphism' op h) => partition (A:=A)). *)
   
   (* Check (fun A (op : A-> A ->A) (e : A)   *)
   (* {e_neutral : Neutral  op e} {op_assoc : Associative op}  *)
   (* (_ : Homomorphism' op  (fun lst => fold_left op lst e)) => partition (A:=A)). *)
   (* Check (fun A (op : A-> A ->A) (e : A)   {e_neutral : Neutral op e} {op_assoc : Associative op}  *)
   (*   (_ : Homomorphism'' op  (fun lst => fold_left op lst e)) => partition (A:=A)). *)

   (* Check (fun A (op : A-> A ->A) (e : A)   {e_neutral : Neutral op e} {op_assoc : Associative op}  *)
   (*   (_ : Homomorphism'' op  (fun lst => fold_left op lst e)) => Homomorphism''_f (B:=A)). *)

   (* Check (fun A (op : A-> A ->A) (e : A)   {e_neutral : Neutral (eqA:=eq) (equ:=eq_equivalence) op e} {op_assoc : Associative (equ:=eq_equivalence)   (eqA:=eq)  op}    => Homomorphism''_f (op:=op) (opass:=op_assoc)(B:=A)(A:=A)). *) 

(* Typeclasses eauto :=  debug dfs 1000000. *)

(* Definition fold_leftPar {A: Type} {op : A-> A ->A} {e : A} {e_neutral : Neutral op e} {op_assoc : Associative  op}:=  *)
(*   parallel (f:=(fun lst => fold_left op lst e))   (Parallelizable := parallel_parallelizable (fun lst => fold_left op lst e) ). (H:=homomorphism_Parallel _ _ _ _)). *)

(*  Global Instance fold_leftParCorrect {A : Type} {op : A-> A ->A} {e : A}  {e_neutral : Neutral op e} {op_assoc : Associative  op}  :  Parallel *)
(*  (B_Partition :=(@homo_result_part _ _ _ (fun l => fold_left op l e) _))  (fun l => fold_left op l e) (fun l => fold_leftPar op e l)  . *)
(*  apply homomorphism_Parallel. *)
(* Defined. *)

(*   (* Definition fold_leftPar {A : Type} (op : A-> A ->A) (e : A)  {e_neutral : Neutral op e} {op_assoc : Associative  op} := *) *)
(*   (*    (parallel (f:=(fun l => fold_left op l e))).    *) *)

  (** to Parallelize a reduction :

     the dummy way
     *)
 
 (*  Definition fold_leftPar {A : Type} (op : A-> A ->A) l (e : A)  {e_neutral : Neutral op e} {op_assoc : Associative  op} := *)
 (*    Eval simpl in (parallel (f:=(fun l => fold_left op l e))  (BPart :=(@homo_result_part _ _ _ (fun l => fold_left op l e) _)) l ). *)
 (*  Check (fun l => fold_leftPar plus l 0). *)

 (*  Global Instance fold_leftParCorrect (A : Type) (op : A-> A ->A) (e : A)  {e_neutral : Neutral op e} {op_assoc : Associative  op}  :  Parallel *)
 (*    (BPart :=(@homo_result_part _ _ _ (fun l => fold_left op l e) _))  (fun l => fold_left op l e) (fun l => fold_leftPar op l e)  . *)
 (*  apply homomorphism_Parallel. *)
 (* Defined. *)

 (* Definition sumDummy:=fun l => fold_left plus l 0. *)
 (* Definition sumDummyPar:=fun l => fold_leftPar plus l 0. *)
 (* Instance isSumOk : Parallel sumDummy sumDummyPar :=(fold_leftParCorrect nat plus 0) .   *)

(* Set Printing All. *)
(*  Definition multDummy:=fun l => fold_left mult l 1. *)
(*  Definition multDummyPar:=fun l => fold_leftPar mult l 1. *)
(*  Instance isMultOk : Parallel multDummy multDummyPar:=(fold_leftParCorrect nat mult 1) .   *)
(* Set Printing All. *)


  (** the nice way     
     you need the following instance  in your environement :
       {e_neutral : Neutral op e} {op_assoc : Associative  op}

       here [op] is [plus] and [e] is [0]
       
       first define a data partition using default value anywhere but at processor 0 *)
   Instance nat_part :Partitionnable nat := LastParallel.partition_A_default nat 0.
  (* then parallelize, its free :)   *)
  Definition sumPar :=
    (parallel (f:=(fun l => fold_left plus l 0))).   

  Hint Unfold   sumPar homo''Par  homo''Par' LastParallel.parallel_last homomorphism''ParallelKernel LastParallel.option_parallel_last   :Parallel.
  Definition sum_bsml_with_spec : {f | f = sumPar}.
      eexists.
      repeat (autounfold with Parallel; simpl).
      reflexivity.
  Defined.

  Definition sum_bsml := Eval simpl in proj1_sig sum_bsml_with_spec.

 
End  FoldLeftPar.

Module Make (Bs : PRIMITIVES) 
  (Bsml_prop : Properties.TYPE Bs) 
  (ParSig : ParSig.TYPE Bs Bsml_prop) 
  (Bsml_base : Base.TYPE Bs Bsml_prop ParSig)  
  (Parallel : Parallelisation )
  (Partition : Lists.TYPE Bs Bsml_prop ParSig Bsml_base Parallel)
  (Bsml_bh : bh_bsml.TYPE  Bs Bsml_prop ParSig Bsml_base Parallel Partition) 
  (Bh_Classes : bh_classes.TYPE Bs Bsml_prop ParSig Bsml_base Parallel Partition Bsml_bh)
  (Ma : map_around.TYPE  Bs Bsml_prop ParSig Bsml_base Parallel Partition Bsml_bh Bh_Classes)
  (LastParallel : LastPar.TYPE Bs Bsml_prop ParSig Bsml_base Parallel Partition)
  (Scan  : scan.TYPE Bs Bsml_prop ParSig Bsml_base Parallel Partition Bsml_bh Bh_Classes Ma) 
  (Homomorphism :homomorphism.TYPE Bs Bsml_prop ParSig Bsml_base Parallel Partition Bsml_bh Bh_Classes Ma LastParallel). 
  
  Include  FoldLeftPar Bs Bsml_prop ParSig Bsml_base Parallel Partition Bsml_bh Bh_Classes Ma LastParallel Scan Homomorphism.

End Make.
