open Datatypes
open List0


(* Module containing instance of mps *)
open ModuleInstances

open Mps_parameters
open Bsml_nat

open Mps_direct

open Bsml
open Stdlib
open Base
open Comm

open Benchmarking
open DataGenerator

module Mps_instance_float  = ( (MaximumPrefixSumInstance ( Bsml_natural ) )  (Mps_float) ) 

let mps_extracted  size data  =    Mps_instance_float.mps_bsml data
let mps_uncertified  size data  =    Mps_direct.mps data

let coq_generator x =  float_of_int (Random.int 1000 - 500)
let direct_generator x =  float_of_int (Random.int 1000- 500)

let _ =
  Random.self_init();
  Benchmarking.benchmarking mps_extracted coq_generator mps_uncertified direct_generator mps_uncertified   (fun a b ->  (proj a 0 = b))  (fun a -> a) print_float print_float (parprint print_float)  print_float
