open Datatypes
open List0

open ModuleInstances		    
open ModuleInstances_defunct
open Tower_building_direct_implementation

open Tower_parameters
open Bsml_nat

open Bsml
open Stdlib
open Base
open Comm

open Benchmarking

module Tower_instance_float = (ModuleInstances.TowerInstance (Bsml_natural)) (Tower_float)

module Tower_instance_float_defunct = (ModuleInstances_defunct.TowerInstance (Bsml_natural)) 


let towerCoq = fun size  data -> Tower_instance_float.coq_Parallel_tower  0. 500. (float(size)) 500. data

let towerCoqDefunct = fun size  data -> Tower_instance_float_defunct.coq_Parallel_tower  0. 500. (float(size)) 500. data

let towerDirect = fun size  data -> Tower_building_direct_implementation.tower_building  (0., 500.)  data ((float(size)), 500.) 0.

let coq_generator x =  Coq_pair (float_of_int x,Random.float 10.)
let direct_generator x =  (float_of_int x,Random.float 10.)

let convertor = function Coq_pair (a, b) -> (a,b)

let rec print_bool_list bl = match bl with [] -> () | b::t -> if b then print_string "1" else print_string "0" ; print_bool_list t

let print_par_list_bool pb =  
  let i=ref 0 in
  let vals = proj pb in
  while !i < bsp_p do
    print_bool_list (vals !i ) ; print_string "|";
    i:=!i+1
  done;
  print_string "\n"


let _ = 
  Benchmarking.program_name:="TowerBuilding";
  Random.self_init();
in
benchmarking   towerCoq coq_generator towerDirect direct_generator towerCoqDefunct    
  (fun va vb ->  proj (fold_direct (&&) (parfun2 (fun a b ->  a = b) va vb)) 0)  
  convertor 
  (function Coq_pair (a, b) -> print_string "(";print_float a; print_string ","; print_float b;print_string ")") 
  (fun  (a, b) -> print_string "(";print_float a; print_string ","; print_float b;print_string ")") 
  (fun v -> print_string "\ncoq " ; print_par_list_bool v  )
  (fun v -> print_string "\nDir " ; print_par_list_bool v  )
  
