open Datatypes
open List0
open Nat_tools
 
open Tower_building 		    
open Tower_parameters
open Bsml_nat

open Bsml
open Stdlib
open Base

open Data_generator

module Tower_instance_float = (Tower (Bsml_natural)) (Tower_float)


let tower = Tower_instance_float.coq_Parallel_tower 

let rec string_of_Coq_list string_of_element separator = function
    |Coq_nil  -> ""
    |Coq_cons (h, Coq_nil) -> string_of_element h
    |Coq_cons (h, t)      -> (string_of_element h)^separator^
       (string_of_Coq_list string_of_element separator t)
	  
let string_of_data d =  match d with Coq_pair (x,h) -> string_of_float ( x) ^","^string_of_float ( h)
let par_print_bool_lst = parprint (fun l ->(print_string (string_of_Coq_list string_of_bool " ; " l)))
let par_print_data_lst = parprint (fun l ->(print_string (string_of_Coq_list (fun c ->string_of_data c)  " ; " l)))

let nb_data=1
let v1 = balanced_fixed_data_par  nb_data

let left_point_pos = 0.
let left_point_height =float_of_int(bsp_p/2*nb_data )
let right_point_pos = float_of_int(nb_data *(bsp_p-1)+2)
let right_point_height = left_point_height

let r_angles = parfun (map (fun p ->match p with  Coq_pair (x,h)  -> Coq_pair(right_point_pos-.x  , Tower_float.coq_AngleR right_point_pos right_point_height x h))) v1
let l_angles = parfun (map (fun p ->match p with  Coq_pair (x,h)  -> Coq_pair(x-.left_point_pos  , Tower_float.coq_AngleL left_point_pos left_point_height x h))) v1
let v1'= tower left_point_pos left_point_height  right_point_pos right_point_height  v1

let sync () = put(replicate(fun i->()))

let _ =
  begin
    sync();
    bsml_print print_string 0 (replicate ("v1=\n"^string_of_float ( left_point_pos) ^","^string_of_float ( left_point_height)^"\n"));
    sync();
    par_print_data_lst v1; 
    bsml_print print_string 0 (replicate ("r_angles= (distance,angle)\n"));
    par_print_data_lst r_angles; 
    bsml_print print_string 0 (replicate ("l_angles= (distance,angle)\n"));
    par_print_data_lst l_angles; 
    bsml_print print_string 0 (replicate (string_of_float ( right_point_pos) ^","^string_of_float ( right_point_height)^"\n"));
    sync();
    bsml_print print_string 0 (replicate "v1'=\n");
    sync();
    par_print_bool_lst v1'; 
  end
(*   (tower 1. 0. (10. *. (float_of_int bsp_p)+.1.) 0. ) (datapar 10); *)

(* (\** File name for logging banchmark  *\) *)
(* let file = "Benchmark"^(string_of_float (Sys.time()) )  *)

(* (\** output channel for logging banchmark  *\) *)
(* let outchan = open_out file  *)


(* (\** Benchmark logging  *\) *)
(* let save_bench name time result = *)
(*   fprintf outchan "Bench %s in time %f" name time *)



(* (\** Benchmark i compute tower building for (i modulo 5  times 100) data, over 2^(i/5) processors *\) *)
(* let benchcompute  i = i *)
(* (\*   tower (data ((i mod 5)*100)) (puissance 2 (i/5)) *\) *)

(* (\** phrase displayed in log before Benchmark results *\) *)
(* let benchname  i = *)
(*   "tower over "^(string_of_int ((i mod 5)*100))^" elements and "^string_of_int (puissance 2  (i/5))^" processors" *)





(* (\** Banchmarks Launching  *\) *)

(* let rec benchmarking_aux i = *)
(*   let t1= Sys.time() in *)
(*   let result = benchcompute i in *)
(*   let t2 = Sys.time() in *)
(*     save_bench (benchname i) (t2-.t1) result;  *)
(*     if i>0 then benchmarking_aux (i-1) *)
(* ;; *)

(* benchmarking_aux 100 ; close_out outchan *)
	    
