open Bsml
open Stdlib.Base
open List

let map3 f l1 l2 l3 = 
  let rec aux acc = function
    |[], _ , _  -> acc
    | _, [], _  -> acc
    | _, _ , [] -> acc
    |h1::t1,h2::t2,h3::t3->
       aux ((f h1 h2 h3)::acc) (t1,t2,t3) in
    aux [] (l1,l2,l3)

let sequence n1 n2 = 
  let rec aux acc n2 = 
    if (n1>n2) then acc else aux (n2::acc) (n2-1) in
  aux [] n2

let compose f g x = f (g x)

let procs_left  = mkpar(fun i->sequence 0 (i - 1))

let procs_right = mkpar(fun i->sequence (i + 1) (bsp_p - 1))

let cpt = ref 0
let string_of_bytes f= 
  let f2,suff =
    if f < 10240. then
      (f,"b") else
	if f < (10240.*.1024.) then
	  (f/.1024.,"Kb") else
	if f < (10240.*.1024.*.1024.) then
	  (f/.(1024.*.1024.),"Mb") 
	else
	  (f/.(10240.*.1024.*.1024.),"Gb") 
  in
    (string_of_float f2)^suff
    
let dir_impl_debug = ref false
let check str = 
  if (!dir_impl_debug && (!cpt mod 10000) == 0) then (print_string ("\n"^str^"  iteration "^(string_of_int !cpt)^"\n"^(string_of_bytes (Gc.allocated_bytes ()))^" allocated \n");Gc.print_stat stdout);cpt:=!cpt+1

let tower_building (xl,hl) lv (xr,hr) htower =
  let _ = cpt:=0; (* Gc.compact() ;  *)check "init" in
  let tan_l (x,h) = let _ = check "left " in (h -. hl) /. (x -. xl) in
  let tan_r (x,h) = let _ = check "right " in(h -. hr) /. (xr -. x) in
  let maxtans_l =
    parfun (fold_left (fun (m,acc) p -> 
			 let m = max (tan_l p) m in 
			   m, m :: acc) (neg_infinity,[])) lv in
  let maxtans_r =
    (* parfun (fold_left (fun (m,acc) p ->  *)
    (* 			 let m = max (tan_l p) m in  *)
    (* 			   m, m :: acc) (neg_infinity,[])) lv in *)
    parfun (fun l ->fold_right (fun p (m,acc) ->
    				  let m = max (tan_r p) m in
    				    m, m :: acc) l (neg_infinity,[])) lv in
  let maxtan_l,maxtanlist_l = 
    parfun fst maxtans_l, parfun (compose rev snd) maxtans_l in
  let maxtan_r,maxtanlist_r = 
    parfun fst maxtans_r, parfun snd maxtans_r in
  let comms = put(apply2 (mkpar(fun i ml mr dest -> 
				  if dest < i then mr
                                  else if dest > i then ml
                                  else 0.)) maxtan_l maxtan_r) in
  let fold comms procs = 
    fold_left (fun acc j -> max acc (comms j)) neg_infinity procs in
  let maxl = parfun2 fold comms procs_left 
  and maxr = parfun2 fold comms procs_right in
  let _ =  check "main" in
    apply3(parfun2 (fun maxl maxr->
	       map3 (fun tan_l (x,h) tan_r -> 
		       (h +. htower -. hl) /. (x -. xl) > max tan_l maxl && 
			 (h +. htower -. hr) /. (xr -. x) > max tan_r maxr))
	     maxl maxr)
      maxtanlist_l lv maxtanlist_r
