open Bsml
open Stdlib
open Base
open Comm
open Tower_building_direct_implementation

let data i j=
  Random.self_init(); 
  let rec data_aux i l size=
  if i = 0 then l else data_aux  (i-1) ((float_of_int ((i+j*size)), (float_of_int (Random.int 1000)))::l) size
  in
    data_aux i [] i

let datapar i =
  mkpar (data (i/bsp_p))

let _ = 
  begin
    if Array.length(Bsml.argv)=2
    then
      begin 
	Gc.set { (Gc.get ()) with Gc.minor_heap_size = 1024*1024*1024*100 };
        Gc.set { (Gc.get ()) with Gc.space_overhead = 99};	
	let length = int_of_string(Bsml.argv.(1)) in
	let v = datapar length in
	  (* memorizing minor collection performed until now *)
	let start_minor_collection_vector= << let stat =Gc.stat() in stat.Gc.minor_collections>> in
	  (* cost for gc and application start at 0 *)
	let gc_cost= << ref 0. >> in
	let cost = << ref 0. >> in 
          begin 
	    (* performing major collection *)
            Gc.full_major();
	    (* starting APPLICATION TIMING *)
	    start_timing();
	    let vl = tower_building (0.,500.) v (float(length),500.) 10. in
	      stop_timing();
	      (* end of application timing;
		 getting cost *)		   
              let cost_vec=Bsml.get_cost() in
		ignore(<< $cost$:=( $cost_vec$ +. ! ($cost$)) >>);
		(* performing GARBAGE collection *)
		Bsml.start_timing();
		Gc.full_major();
		Bsml.stop_timing();
		(* getting GC cost *)
		ignore( << $gc_cost$ := $Bsml.get_cost()$ +.  ! $gc_cost$>>);
		
	  end;
	  (* printing COMPUTATION TIMING *)
	  ignore (<< if ( $this$ = 0 ) then (
		    print_float ! $cost$ ; 
		    print_string ";")
		  else () >> );
	  let word_vector= << let stat =Gc.stat() in stat.Gc.minor_words +.  stat.Gc.major_words -. stat.Gc.promoted_words>> in
	  let minor_collection_vector= << let stat =Gc.stat() in stat.Gc.minor_collections>> in
	    ignore (<< if ( $this$ = 0 ) then 
		      (* printing MEMORY 'CONSUMPTION' *)
		      ( print_float $word_vector$; 
			print_string ";";
			(* printing Number of GARBAGE collection *)
			print_int ($minor_collection_vector$ - $start_minor_collection_vector$); 
			print_string ";") else () >> );
	      (* printing  GARBAGE collection TIMING *)
	      ignore (<< if ( $this$ = 0 ) then ( print_float ! $gc_cost$ )  else () >> )

      end
    else
      print_string "give a length as argument\n"
  end

  



