open Datatypes
open List0

open ModuleInstances
open Tower_parameters
open Bsml_nat

open Tower_building_direct_implementation

open Bsml
open Stdlib
open Base
open Comm

open Benchmarking
open DataGenerator

module Tower_instance_float = (TowerInstance (Bsml_natural)) (Tower_float)
let tower_coq  size data  =   Tower_instance_float.coq_Parallel_tower 0. 500. (float(size)) 500. data
let tower_direct size data = tower_building (0.,500.) data (float(size),500.) 0. ;;


let _ =
  begin 
    Gc.set { (Gc.get()) with Gc.verbose = 0x00f };
    print_string "\n";
    output_string  Pervasives.stderr "\n";
    flush Pervasives.stdout;  
    flush Pervasives.stderr;


    (* Gc.set { (Gc.get ()) with Gc.minor_heap_size = 1*1024*1024*1024 }; *)
    if Array.length(Bsml.argv)=2
    then
      let length = int_of_string(Bsml.argv.(1)) in
    (* (\* coq version  *\) *)
    (* coq_small_default_benchmark tower_coq 300 "tower_building_coq"; *)
    (* (\* direct implementation version  *\) *)
    (* small_default_benchmark tower_direct 300 "tower_building_direct"; *)

    (* direct implementation version  *)
    one_size_default_benchmark  local_pos_data_list_generator tower_direct 300 "tower_building_direct" length;
    (* coq version  *)
    one_size_default_benchmark coq_local_pos_data_list_generator tower_coq 300 "tower_building_coq" length
    else
      print_string "give a length as argument\n"
  end
